if (version$major > 4)
{
setOldClass(c("pmat","block","vstack"))
setOldClass("yags")
}
  yags <- function(formula, id, weights = NULL, cor.met = NULL, family = gaussian, alpfun
           = NULL, scalefun = LZ.scalefun, wcorigen = identni, tol = 0.00001,
          contrasts = NULL, corstr = c("independence", "exchangeable", "ar1",
          "unstructured"), maxiter = 25, alphainit = 0, hardcode = F, binit =
          NULL, verbose = F, Ua.tol = 1e-06, Ua.maxit = 20, Ua.gridlo = 0.1,
          Ua.gridhi = 0.9, Ua.gridnpts = 10, Ua.secantdel = 0.01)
  {
          prog.error <- NULL
          corstr <- corstr[1] # option list curtailed if default chosen
          if(is.null(cor.met) & !(corstr == "independence" | corstr ==
                  "exchangeable"))
                  stop("must supply cor.met for non-independence, non-exchangeable"
                          )
          if (corstr == "unstructured" && any(cor.met - floor(cor.met)))
             {
             warning("cor.met not lattice-valued; flooring")
             cor.met <- floor(cor.met)
             }
          if (corstr == "unstructured" && hardcode)
             {
             if (min(cor.met)!=0) {
               warning("cor.met must have global zero origin for hardcode unstructured, recentering")
               cor.met <- cor.met-min(cor.met)
             }
             spltim <- split.preserveord(cor.met,id)
             I <- length(spltim)
             for (i in 1:I) {
                    ut <- unique(spltim[[i]])
                    if(length(ut)!=length(spltim[[i]])) stop("floored cor.met has repetitions in some cluster; obs times in a cluster must be unique")
                            }
             }
  	        call <- match.call()
	        m <- match.call(expand = F)
	        m$contrasts <- m$tol <- m$wcorigen <- m$scalefun <- m$alpfun <- m$
	                family <- m$cor.met <- m$id <- m$corstr <- m$maxiter <- m$
	                alphainit <- m$hardcode <- m$binit <- m$verbose <- m$Ua.tol <- m$
	                Ua.maxit <- m$Ua.gridlo <- m$Ua.gridhi <- m$Ua.gridnpts <- 
	                m$Ua.secantdel <- NULL
	        m[[1]] <- as.name("model.frame")
	        m <- eval(m, sys.parent())
	        Terms <- attr(m, "terms")
	        y <- as.matrix(model.extract(m, response))
	        # 1.5.1.1 B : add weight-processing specifically for binomial matrices
	        # corrected in 1.5.1.3!!
	        # as in glm()
	        if(is.null(weights)) weights <- rep(1, nrow(y)) else if(length(weights) !=
	                nrow(y))
	                stop("lengths of y and weights incompatible")
	        if(ncol(y) == 2) {
	                n <- apply(y, 1, sum)
	                y <- y[, 1, drop = F]/n
	                weights <- 1/(weights * n)
	        }
	        else weights <- 1/weights
	        # end of change block B 1.5.1.1
	        x <- model.matrix(Terms, m, contrasts)
	        if(!hardcode) {
	                Y <- load.clustered.outcome(y, id)
	                X <- load.clustered.design(x, id)
	        }
	        else {
	                Y <- y
	                X <- x
	        }
	        if (hardcode & !is.null(alpfun))
	           warning("hardcode==T and non-null alpfun; alpfun overridden by corstr")
	    if(!hardcode) # for hardcode, corstr string determines model
	      {
	        if(!is.null(alpfun) &  corstr !="independence")
	                warning("both alpfun and non-default corstr provided; corstr will be ignored"
	                        )
	        else if(corstr[1] == "exchangeable" ) {
	                alpfun <- LZ.exchalp
	                wcorigen <- excoriput
	        }
	        else if(corstr[1] == "ar1" ) {
	                if(is.null(cor.met))
	                        stop("must supply times (cor.met) with ar1")
	                # use next line to emulate SAS 6.12 genmod
	                #alpfun <- prop.ar1alp
	                # use next line to emulate yags hardcode ar1
	                alpfun <- UG.alpfun.fom
	                wcorigen <- ar1.coriput
	        }
	        else if(corstr[1] == "unstructured" ) {
	                if(is.null(cor.met))
	                        stop("must supply times (cor.met) with unstructured")
	               # use next two lines to emulate genmod 6.12
	               #alpfun <- prop.unstruc.alp
	               #wcorigen <- unstr.coriput
	               # use next two lines for emulation of Groemping macro unstr
	               # (and hardcode yags unstr)
	                alpfun <- heidel.unstruc.alp
	                wcorigen <- heidel.unstruc.coviput
	        }
	        else if(is.null(alpfun) & corstr[1] == "independence") {
	                alpfun <- function(a, b, c, d, p, alp)
	                0
	                wcorigen <- identni
	        }
	        else if(corstr[1] == "UG.fom") {
	                alpfun <- UG.alpfun.fom
	                wcorigen <- fom.coriput
	        }
	     }
          if(!hardcode) ans <- yags.pmat.fit(X, Y, id, weights, cor.met, family,
                          alpfun, scalefun, wcorigen, tol, maxiter, prog.error,
                          alphainit, binit) else 
                        ans <- yags.CC(X, Y, id, cor.met,
                          family = family, corstr = corstr, alpin = alphainit,
                          betin = binit, Ua.tol = Ua.tol, Ua.maxit = Ua.maxit,
                          verbose = verbose, Ua.gridlo = Ua.gridlo, Ua.gridhi =
                          Ua.gridhi, Ua.gridnpts = Ua.gridnpts, Ua.secantdel =
                          Ua.secantdel, weights=weights)
  		ans$call <- call
	        ans$hardcode <- hardcode
	        ans$corstr <- corstr
	       	#oldClass(ans) <- c("yags")#,"glm","lm")
	    if (version$major < 5)
		class(ans) <- c("yags","glm","lm")
	    else
	       	oldClass(ans) <- c("yags")#,"glm","lm")
		ans

  }

  # 1.5.1.1 D receive weights
  yags.pmat.fit <-
  function(X, Y, ID, weights, cor.met, family, alpfun, scalefun, 
       wcorigen, tol, maxiter, prog.error, alphainit, binit)
  {
  	MX <- pmat2mat(X)
  	xn <- dimnames(X[[1]])[[2]]
  	dimnames(MX) <- list(NULL,xn)
  	if (is.null(binit)) 
             {
             initrun <- glm(unlist(Y) ~ MX - 1, family = family, weights=weights)
  	   b0 <- initrun$coef
             }
          else b0 <- binit
          cur.rank <- sum(eigen(t(MX)%*%MX)$val > 0) # bad!
  	del <- 1
  	assign("glm.links", yags.links, f = 1)
  	iter <- 0
  	alpha <- alphainit
  	while(del > tol & iter < maxiter) {
  		iter <- iter+1
  		print(paste("Starting iteration",iter,"with coefs"))
  		print(as.numeric(b0))
  		eta <- MX %*% b0 # 
  		mu <- family()$inverse(eta) # 
  		d.mu <- family()$deriv(mu) # 
  # 1.5.1.1 E use weights
  		A <- as.double(family()$variance(mu)) * weights # 
  		if(length(A) == 1)
  			A <- rep(A, length(unlist(Y)))
                  # 
  		D.i <- load.clustered.design((1/sqrt(A)) * as.double(family()$
  			dinv.deta(eta)) * MX, ID)	# D scaled by V(mu)
  		PR <- (1/sqrt(A)) * (unlist(Y) - mu)	# pearson resid
  		if(!is.null(cor.met)&!is.matrix(cor.met))
  			TT <- split.preserveord(cor.met, ID)
  		else if(!is.null(cor.met)&is.matrix(cor.met))
  			TT <- msplit(cor.met, ID)
  		else TT <- NULL
  		alpha <- alpfun(PR, ID, cor.met, scalefun, p = ncol(MX), alpha)
  		PR <- load.clustered.outcome(PR, ID)	
  		cor.els <- list()
  		NC <- length(PR)
  		for(i in 1:NC)
  			cor.els[[i]] <- list(r = PR[[i]], cor.met = TT[[i]], alpha
  				 = alpha)
  		Rinv.i <- fill(wcorigen, cor.els, c("pmat", "block", "diag"))
  		S2 <- solve(sum(t(D.i) %*% Rinv.i %*% D.i))
  		delb <- S2 %*% sum(t(D.i) %*% Rinv.i %*% PR)
  		del <- max(abs(delb))
  		b1 <- b0 + delb
  		b0 <- b1
  	}
  # wrap up using final beta values
  	if (iter == maxiter) {
                     warning("maximum number of iterations consumed")
                     prog.error _ c(prog.error,"niter==maxiter")
                     }
  	eta <- MX %*% b0
  	mu <- family()$inverse(eta)
  	Rvec <- unlist(Y) - mu	# raw residual
  	PR <- (1/sqrt(A)) * Rvec
  	alpha <- alpfun(PR, ID, cor.met, scalefun, p = ncol(MX), alpha)
          sealp <- NA
  	phi <- scalefun(PR, ID, p = ncol(MX))
  	PR <- load.clustered.outcome(PR, ID)
  	for(i in 1:NC)
  		cor.els[[i]] <- list(r = PR[[i]], cor.met = TT[[i]], 
                  alpha = alpha)
  	vvt <- function(x)
  	matrix(x$r %*% t(x$r), nr = length(x$r))
  	eet <- fill(vvt, cor.els, c("pmat", "block", "diag"))
  	Rinv.i <- fill(wcorigen, cor.els, c("pmat", "block", "diag"))
  	S2 <- solve(sum(t(D.i) %*% Rinv.i %*% D.i))
  	S5 <- sum(t(D.i) %*% Rinv.i %*% eet %*% Rinv.i %*% D.i)
  	b1 <- as.numeric(b1)
  	names(b1) <- xn
  	list(coefficients = b1, naive.parmvar = phi * S2, 
                  robust.parmvar = S2 %*% S5 %*% S2, alpha = 
  		alpha, phi = phi, linear.predictors=as.double(eta), 
                  fitted.values=as.double(mu), residuals=as.double(Rvec),
  		iter=iter, family=family, rank=cur.rank, 
                  errorcode=prog.error, sealp=sealp)
  }

  LZ.scalefun <- function(R, ID, cor.met, p)
  {
  # from section 3.3 of LZ 1986
  	N <- length(R)  #
                          #
  	sum(R^2)/(N - p) #
  }

  prop.scalefun <- function(R, ID, cor.met, p)
  {
  # 6.12 tech rept
          Rs <- split.preserveord(R,ID)
          Ms <- lapply(Rs,function(x)mean(x^2))
  	mean(unlist(Ms))
  }

  LZ.exchalp <- function(R, ID, cor.met=NULL, scalefun, p, alpha )
  {
  # example 3, section 4 of LZ 1986
  	residlist <- split.preserveord(R,ID)
  	A0 <- 0
  	den <- 0
  	n <- unlist(lapply(residlist, length))
  	for(i in 1:length(residlist)) {
  		if(n[i] > 1) {
                          # 
                          # 
  			A0 <- A0 + (sum(residlist[[i]] %*% t(residlist[[i]])) - 
  				t(residlist[[i]]) %*% residlist[[i]])/2
                          # 
  			den <- den + 0.5 * n[i] * (n[i] - 1)
  		}
  	}
          # 
  	P <- scalefun(R, ID, cor.met, p)
          # 
  	A0/(P * (den - p))
  }

  strat.exchalp <- function(R, ID, cor.met, scalefun, p, alpha )
  {
  # example 3, section 4 of LZ 1986
  # note at this stage cor.met is a vector
  # this function assumes a common scale parameter;
          residlist <- split.preserveord(R, ID)
          cor.met <- split.preserveord(cor.met, ID)
          if(is.matrix(cor.met[[1]]))
                  stop("strat.exchalp can't handle matrices in cor.met")
          dim.alpha <- length(unique(unlist(cor.met)))
          if(any(sort(unique(unlist(cor.met))) != 1:dim.alpha))
                  stop("strat.exchalp needs cor.met elements 1:n.strata")
          A0 <- rep(0, dim.alpha)
          den <- rep(0, dim.alpha)
          n <- unlist(lapply(residlist, length))
          for(i in 1:length(residlist)) {
                  met.ind <- cor.met[[i]][1]
                  if(n[i] > 1) {
                          A0[met.ind] <- A0[met.ind] + (sum(residlist[[i]] %*% t(
                                  residlist[[i]])) - t(residlist[[i]]) %*% 
                                  residlist[[i]])/2
                          den[met.ind] <- den[met.ind] + 0.5 * n[i] * (n[i] - 1)
                  }
          }
          P <- scalefun(R, ID, cor.met, p)
          A0/(P * (den - p))
  }

  prop.ar1alp <- 
  function(R, ID, cor.met, scalefun, p, alpha)
  {
  # following SAS (tm) 6.12 tech report, p294
          r <- split.preserveord(R, ID)
          times <- split.preserveord(cor.met, ID)
          num <- 0
          den <- 0
          n <- unlist(lapply(r, length))
          for(i in 1:length(r)) {
                  curnum <- 0
                  curden <- 0
                  contrib <- F
                  if(n[i] > 1) {
                          for(j in 1:(n[i] - 1)) {
                                  if((times[[i]][j + 1] - times[[i]][j]) == 1) {
                                    curnum <- curnum + r[[i]][j] * r[[i]][j + 1]
                                    curden <- curden + 1
                                    contrib <- T
                                  }
                          }
                          if(contrib) {
                                  num <- num + curnum/curden
                                  den <- den + 1
                          }
                  }
          }
          P <- scalefun(R, ID, cor.met, p)
          num/(P * den)
  }

  prop.unstruc.alp <- 
  function(R, ID, cor.met, scalefun, p, alpha)
  {
  # following SAS (tm) 6.12 tech report, p294
          r <- split.preserveord(R, ID)
          # elements of cor.met will be used to INDEX the matrix alp
  # thus they must be from 1:nrow(alp)
          if((any(cor.met < 1)) | any(cor.met - floor(cor.met)))
                  stop(paste("for this alpfun (prop.unstruc.alp), all elements of cor.met must be positive integers"
                          ))
          utimes <- 1:max(cor.met)
          nt <- length(utimes)
          q <- (nt * (nt - 1))/2
          alp <- matrix(0, nt, nt)
          den <- matrix(0, nt, nt)
          times <- split.preserveord(cor.met, ID)
          num <- 0
          n <- unlist(lapply(r, length))
          for(i in 1:length(r)) {
                  contrib <- F
                  if(n[i] > 1) {
                          for(j in 1:(n[i] - 1)) {
                                  for(k in (j + 1):n[i]) {
                                    alp[times[[i]][j], times[[i]][k]] <- alp[
                                      times[[i]][j], times[[i]][k]] + r[[i]][j] * 
                                      r[[i]][k]
                                    den[times[[i]][j], times[[i]][k]] <- den[
                                      times[[i]][j], times[[i]][k]] + 1
                                  }
                          }
                  }
          }
          P <- scalefun(R, ID, cor.met, p)
          den <- den + t(den)
          diag(den) <- 1  # avoid div by zero
          alp <- alp + t(alp)
          alp <- alp/(P * den)
          diag(alp) <- 1
          alp
  }
    heidel.unstruc.alp <-
    function(R, ID, cor.met, scalefun, p, alpha)
    {
            r <- split.preserveord(R, ID)
            utimes <- 1:max(cor.met)
            nt <- length(utimes)
            q <- (nt * (nt - 1))/2
            alp <- matrix(0, nt, nt)
            den <- matrix(0, nt, nt)
            times <- split.preserveord(cor.met, ID)
            num <- 0
            n <- unlist(lapply(r, length))
            for(i in 1:length(r)) {
                    contrib <- F
                    if(n[i] > 1) {
                            for(j in 1:n[i]) {
                                    for(k in j:n[i]) {
                                      alp[times[[i]][j], times[[i]][k]] <- alp[
                                        times[[i]][j], times[[i]][k]] + r[[i]][j] * 
                                        r[[i]][k]
                                      den[times[[i]][j], times[[i]][k]] <- den[
                                        times[[i]][j], times[[i]][k]] + 1
                                    }
                            }
                    }
            }
    #P <- scalefun(R, ID, cor.met, p)
            den <- den + t(den)
            diag(den) <- length(r)  # 
            asd <- diag(alp)
            alp <- alp + t(alp)
            diag(alp) <- asd
            alp <- alp/(den - p)
    full2tri(alp) # encode the triangle
    }

    heidel.unstruc.coviput <-
    function(x)
    {
            alpm <- tri2full(x$alpha)
            solve(alpm[x$cor.met, x$cor.met])
    }
   
          tri2full <-
          function(x)
          {
                  k <- length(x)
                  n <- 0.5 * (sqrt(1 + 8 * k) - 1)
                  ans <- matrix(0, n, n)
                  ans[row(ans) >= col(ans)] <- x
                  d <- diag(ans)
                  ans <- ans + t(ans)
                  diag(ans) <- d
                  ans
          }
          full2tri <-
          function(x)
          {
                  if(any(x - t(x)))
                          warning("x not symmetric")
                  as.numeric(x[row(x) >= col(x)])
          }
   



  ngau.m2ll <-
  function(res, alpha, wcorigen, var, id, cor.met)
  {
          print(alpha)
          N <- length(res)
          I <- length(unique(id))
          TT <- split.preserveord(cor.met, id)
          corclass <- unlist(lapply(TT, function(x)
          x[1]))
          sizes <- unlist(lapply(TT, length))
          cor.els <- list()
          for(i in 1:I)
                  cor.els[[i]] <- list(alpha = alpha[corclass[i]], ni = sizes[i])
          Rinv.i <- fill(wcorigen, cor.els, c("pmat", "block", "diag"))
          Siginv.i <- (1/var) * Rinv.i
          D.i <- det(Siginv.i)
          R.i <- load.clustered.outcome(res, id)  # structure resids
          WCPa.i <- t(R.i) %*% Siginv.i
          WCP.i <- WCPa.i %*% R.i # 
                             # 
          N * log(2 * pi) - sum(log(unlist(D.i))) + sum(WCP.i)
  }

  gau.hetex.alp <- 
  function(R, ID, cor.met, scalefun, p)
  {
          assign("ID", ID, 1)
          assign("cor.met", cor.met, 1)
          P <- scalefun(R, ID, cor.met, p)
          ans <- ms( ~ ngau.m2ll(R, alp, nexinv, P, ID, cor.met), start = list(
                  alp = initalp), control = list(maxiter = 15, maxfcalls = 25, 
                  rel.tolerance = 0.0001))$par
          initalp <<- ans
          ans
  }
  nexinv <- function(x)
  {
          n <- x$ni
          r <- x$alpha    # analytic form of inverse of compound symmetry matrix
          den <- (n - 1) * r * r - (n - 2) * r - 1
          ans <- matrix(r/den, nr = n, nc = n)
          diag(ans) <-  - ((n - 2) * r + 1)/den
          ans
  }

      
      UG.alpfun.fom <-
      function(R, ID, cor.met, scalefun, p, alpin)
      {
      	assign("R", R, f = 0)
      	assign("ID", ID, f = 0)
      	assign("cor.met", cor.met, f = 0)
      	assign("p", p, f = 0)
      	tmp <- ms( ~ (UGG.fom(R, ID, cor.met, plogis(r),p))^2, start = list(
      		r = alpin))
      	print(tmp)
      	plogis(tmp$par)
      }

      UGG.fom <-
      function(R, ID, cor.met, rho, p)
      {
      	N <- length(R)
      	phi <- var(R)*(N-1)/(N-p) 
      	eps <- split.preserveord(R, ID)
      	d <- split.preserveord(cor.met, ID)
      	N <- length(eps)
      	U <- 0
      	for(i in 1:N) {
      		ni <- length(eps[[i]])
      		if(ni < 2)
      			next
      		dij <- diff(d[[i]])
      		epsi <- eps[[i]]
      		U <- U + sum((dij * rho^(dij - 1) * ((rho^dij * epsi[ - ni] -
      			epsi[-1]) * epsi[ - ni] + (rho^dij * epsi[-1] - epsi[
      			 - ni]) * epsi[-1]))/(1. - rho^(2 * dij)))
      		# UJ comp
      		U <- U + sum(((dij * rho^(2 * dij - 1) * ((epsi[-1] - epsi[
      			 - ni] * rho^dij)^2 + (epsi[ - ni] - epsi[-1] * rho^
      			dij)^2 - 2 * phi * (1 - rho^(2 * dij)))))/((1 - rho^
      			(2 * dij))^2))
      	}
      	U
      }

      gengmc <- function(r, lam, times)
      {
              o <- dist2full(dist(times^lam)/lam)
              r^o
      }

      genfom <- function(r, times)
      {
              o <- dist2full(dist(times))
              r^o
      }

      gmc.coriput <- function(x)
      solve(gengmc(x$alpha[1], x$alpha[2], x$cor.met))

      fom.coriput <- function(x)
      {
      #although an analytic form for the inverse
      #of the AR(1) ac matrix is available, its use
      #is not so straightforward with gappy data
              solve(x$alpha^dist2full(dist(x$cor.met)))
      }

      genar1 <- function(r, n)
      {
              o <- dist2full(dist(1:n))
              r^o
      }


  excori <- function(x)
  {
  	N <- length(x$r)
  	o <- matrix(x$alpha, nr = N, nc = N)
  	diag(o) <- 1
  	solve(o)
  }
  exinv <- function(r, n)
  {
  # analytic form of inverse of compound symmetry matrix
  	den <- (n - 1) * r * r - (n - 2) * r - 1
  	ans <- matrix(r/den, nr = n, nc = n)
  	diag(ans) <-  - ((n - 2) * r + 1)/den
  	ans
  }

  excoriput <- function(x)
  {
  # quick calculation of exch. working covariance
  	exinv(x$alpha, length(x$r))
  }

  strat.excoriput <- function(x)
  {
  # quick calculation of exch. working covariance
  	exinv(x$alpha[x$cor.met[1]], length(x$r))
  }
  identni <- function(x) # independence model
  {
  # returns the identity matrix
  diag(length(x$r))
  }
  ar1.coriput <- function(x)
  {
  #although an analytic form for the inverse
  #of the AR(1) ac matrix is available, its use
  #is not so straightforward with gappy data
          solve(x$alpha^dist2full(dist(x$cor.met)))
  }
  unstr.coriput <- function(x)
  {
     solve(x$alpha[x$cor.met,x$cor.met])
  }

  yags.links <- structure(.Data = list("Identity: mu", link = function(mu)
  mu, inverse = function(eta)
  eta, deriv = function(mu)
  1, initialize = expression({
  	y <- as.numeric(y)
  	mu <- y
  }
  ), dinv.deta = function(eta)
  {
  	1
  }
  , "Logit: log(mu/(1 - mu))", link = function(mu)
  log(mu/(1 - mu)), inverse = function(eta)
  {
  	junk <- care.exp(eta)
  	junk/(1 + junk)
  }
  , deriv = function(mu)
  {
  	d <- mu * (1 - mu)
  	if(any(tiny <- (d < .Machine$double.eps))) {
  		warning("Model unstable; fitted probabilities of 0 or 1")
  		d[tiny] <- .Machine$double.eps
  	}
  	1/d
  }
  , initialize = expression({
  	if(is.matrix(y)) {
  		if(dim(y)[2] > 2)
  			stop("only binomial response matrices (2 columns)")
  		n <- drop(y %*% c(1, 1))
  		y <- y[, 1]
  	}
  	else {
  		if(is.category(y))
  			y <- y != levels(y)[1]
  		else y <- as.vector(y)
  		n <- rep(1, length(y))
  	}
  	w <- w * n
  	n[n == 0] <- 1
  	y <- y/n
  	mu <- y + (0.5 - y)/n
  }
  ), dinv.deta = function(eta)
  {
  	junk <- care.exp(eta)
  	junk/(1 + junk)^2
  }
  , "Complementary Log: log( - log(1 - mu))", link = function(mu)
  log( - log(1 - mu)), inverse = function(eta)
  {
  	junk <- care.exp(eta)
  	1 - care.exp( - junk)
  }
  , deriv = function(mu)
  {
  	mu2 <- 1 - mu
  	d <-  - (mu2 * log(mu2))
  	if(any(tiny <- (d < .Machine$double.eps))) {
  		warning("Model unstable; fitted probabilities of 0 or 1")
  		d[tiny] <- .Machine$double.eps
  	}
  	1/d
  }
  , initialize = expression({
  	if(is.matrix(y)) {
  		if(dim(y)[2] > 2)
  			stop("only binomial response matrices (2 columns)")
  		n <- drop(y %*% c(1, 1))
  		y <- y[, 1]
  	}
  	else {
  		if(is.category(y))
  			y <- y != levels(y)[1]
  		else y <- as.vector(y)
  		n <- rep(1, length(y))
  	}
  	w <- w * n
  	n[n == 0] <- 1
  	y <- y/n
  	mu <- y + (0.5 - y)/n
  }
  ), dinv.deta = function(eta)
  {
  	junk <- care.exp(eta)
  	care.exp(eta - junk)
  }
  , "Probit: qnorm(mu)", link = function(mu)
  qnorm(mu), inverse = function(eta)
  pnorm(eta), deriv = function(mu)
  sqrt(2 * pi) * exp((qnorm(mu)^2)/2), initialize = expression({
  	if(is.matrix(y)) {
  		if(dim(y)[2] > 2)
  			stop("only binomial response matrices (2 columns)")
  		n <- drop(y %*% c(1, 1))
  		y <- y[, 1]
  	}
  	else {
  		if(is.category(y))
  			y <- y != levels(y)[1]
  		else y <- as.vector(y)
  		n <- rep(1, length(y))
  	}
  	w <- w * n
  	n[n == 0] <- 1
  	y <- y/n
  	mu <- y + (0.5 - y)/n
  }
  ), dinv.deta = function(eta)
  {
  	dnorm(eta)
  }
  , "Log: log(mu)", link = function(mu)
  log(mu), inverse = function(eta)
  care.exp(eta), deriv = function(mu)
  1/mu, initialize = expression({
  	if(!is.null(dimy <- dim(y))) {
  		if(dimy[2] > 1)
  			stop("multiple responses not allowed")
  		else y <- drop(y)
  	}
  	else y <- as.numeric(y)
  	mu <- y + 0.167 * (y == 0)
  }
  ), dinv.deta = function(eta)
  {
  	care.exp(eta)
  }
  , "Inverse: 1/mu", link = function(mu)
  1/mu, inverse = function(eta)
  1/eta, deriv = function(mu)
  -1/mu^2, initialize = expression({
  	y <- as.numeric(y)
  	mu <- y + 0.167 * (y == 0)
  }
  ), dinv.deta = function(eta)
  {
  	-1/eta^2
  }
  , "Inverse Square: 1/mu^2", link = function(mu)
  1/mu^2, inverse = function(eta)
  sqrt(1/eta), deriv = function(mu)
  -2/mu^3, initialize = expression({
  	mu <- y + 0.167 * (y == 0)
  }
  ), dinv.deta = function(eta)
  {
  	-0.5 * eta^(-1.5)
  }
  , "Square Root: sqrt(mu)", link = function(mu)
  sqrt(mu), inverse = function(eta)
  eta^2, deriv = function(mu)
  1/(2 * sqrt(mu)), initialize = expression({
  	y <- as.numeric(y)
  	mu <- y + 0.167 * (y == 0)
  } # for hardcode, corstr string determines model
  ), dinv.deta = function(eta)
  {
  	2 * eta
  }
  ), .Dim = c(6, 8), .Dimnames = list(c("names", "link", "inverse", "deriv", 
  	"initialize", "dinv.deta"), c("identity", "logit", "cloglog", "probit", 
  	"log", "inverse", "1/mu^2", "sqrt")))


  	pmat <- function( classdef, p=NULL)
		{
		out <- list()
		class(out) <- c("pmat",classdef)
		out
		}
  	fill <- function( matfun, genarg, outclass )
		{
	# version 1.5.1.5 98/08/26
	# matfun takes one argument of undetermined type
	# matfun must return an s-matrix
	#
	# genarg must be a list, elements of which are
	# recognizeable to matfun 
	#
	# outclass will only be partly checked
	#
	        I <- length(genarg)
	        out <- lapply(genarg, matfun)
	        cdims <- unlist(lapply(out, function(x)
	        ncol(x)))
	        rdims <- unlist(lapply(out, function(x)
	        nrow(x)))
	        ccom <- F
	        rcom <- F
	        if(all(cdims == cdims[1]))
	                ccom <- T
	        if(all(rdims == rdims[1]))
	                rcom <- T
	        if(match("vstack", outclass, nom = F) & !ccom)
	                warning("output is not a vstack (different cdim elements)")
	        if(match("hstack", outclass, nom = F) & !rcom)
	                warning("output is not an hstack (different rdim elements)")
	        class(out) <- outclass
	        attr(out, "cdims") <- cdims
	        attr(out, "rdims") <- rdims
	        out
	}

  	t.pmat <- function(x)
		NextMethod("t.pmat")

	t.pmat.block <- function(x,...)
		NextMethod("t.pmat.block")

	t.pmat.block <- function( pmat )
		{
		out <- list()
		out <- lapply(pmat,t)
		attributes(out) <- attributes(pmat)
		attr(out,"rdims") <- attr(pmat,"cdims")
		attr(out,"cdims") <- attr(pmat,"rdims")
		if (inherits(pmat,"vstack"))
			class(out) <- c("pmat","block","hstack")
		if (inherits(pmat,"hstack"))
			class(out) <- c("pmat","block","vstack")
		if (inherits(pmat,"diag"))
			class(out) <- c("pmat","block","diag")
		out
		}

	"%*%.pmat" <- function(x,y,...)
		{
		NextMethod("%*%.pmat")
		}

	"%*%.pmat.block" <- function(x,y,...)
	{
		nelx <- length(x)
		nely <- length(y)
		if(nelx != nely)
			stop("nonconforming pmats (different numbers of blocks)")
		if(length(attr(x, "cdims")) > 0 & length(attr(y, "rdims")) > 0) {
			if(any(attr(x, "cdims") != attr(y, "rdims")))
				stop("nonconforming pmats")
		}
		if(!is.loaded(symbol.C("pmat_mult"))) {
			out <- list()
			for(i in 1:nelx) {
				out[[i]] <- x[[i]] %*% y[[i]]
			}
		}
		else {
			xr <- attr(x, "rdims")
			yc <- attr(y, "cdims")
			ans <- list()
			for(i in 1:nelx) {
				if(any(c(dim(x[[i]]), dim(y[[i]])) == 0) | is.null(dim(
					x[[i]])) | is.null(dim(y[[i]])))
					stop(paste("some factor (", i, 
					  ") has improper dimension"))
				ans[[i]] <- matrix(0, nr = xr[i], nc = yc[i])
			}
			z <- .C("pmat_mult",
				x,
				y,
				ans = ans,
				as.integer(length(x)))
			out <- z$ans
		}
		class(out) <- c("pmat", "block")
		if(inherits(x, "diag") & inherits(y, "diag"))
			class(out) <- c(class(out), "diag")
		attr(out, "rdims") <- attr(x, "rdims")
		attr(out, "cdims") <- attr(y, "cdims")
		out
	}

	"*.pmat" <- function(x,y,...)
		{
		NextMethod("*.pmat")
		}

	is.scalar <- function(x)
		is.atomic(x) & length(x) == 1

	"*.pmat.block" <- function(x,y,...)
		{
		if (!is.scalar(x)) stop("* only defined for scalar * pmat")
		out <- list()
		for (i in 1:length(y))
			out[[i]] <- x*y[[i]]
		attributes(out) <- attributes(y)
		class(out) <- class(y)
		out
		}

	"+.pmat" <- function(x,y,...)
		{
		NextMethod("+.pmat")
		}

	"+.pmat.block" <- function(x,y,...)
	{
	        nelx <- length(x)
		if(length(x) != length(y))
			stop("+: pmats must be of same length")
		if(!(all(attr(x, "cdims") == attr(y, "cdims")) & all(attr(x, "rdims") == 
			attr(y, "rdims"))))
			stop("nonconforming addends")
		if(!is.loaded(symbol.C("pmat_add"))) {
			out <- list()
			for(i in 1:nelx)
				out[[i]] <- x[[i]] + y[[i]]
		}
		else {
			out <- 0 * x
			for (i in 1:nelx)
			     if(any(c(dim(x[[i]]), dim(y[[i]])) == 0) | is.null(dim(
				x[[i]])) | is.null(dim(y[[i]])))
				stop(paste("some factor (", i, 
				  ") has improper dimension"))
			z <- .C("pmat_add",
				x,
				y,
				ans = out,
				as.integer(length(x)))
			out <- z$ans
		}
		attributes(out) <- attributes(x)
		out
	}


	sum.pmat <- function(x,na.rm=F)
		NextMethod("sum.pmat")

	sum.pmat.block <- function(x,na.rm=F)
		{
		if (!(all(attr(x,"cdims")==attr(x,"cdims")[1]) &
	     all(attr(x,"rdims")==attr(x,"rdims")[1]))) stop("needs all dimensions common")
	if (!is.loaded(symbol.C("pmat_sum")))
	{
		out <- x[[1]]
		for (i in 2:length(x))
			out <- out+x[[i]]
		class(out) <- "matrix"
	}
	else 
	{
		ans.space <- 0*x[[1]]
		z <- .C("pmat_sum", x, as.integer(length(x)), ans=ans.space)
		out <- z$ans
	}
	out
	}

	solve.pmat<- function(x,...)
		NextMethod("solve.pmat")

	det.pmat<- function(x,...)
		NextMethod("det.pmat")

	solve.pmat.block <- function(x,...)
		NextMethod("solve.pmat.block")

	det.pmat.block <- function(x,...)
		NextMethod("det.pmat.block")

	solve.pmat.block.diag <- function(x)
		{
		out <- lapply(x,solve)
		attributes(out) <- attributes(x)
		out
		}

	det <- function(x)
	UseMethod("det")

	det.default <- function(x)
	prod(eigen(x)$val)

	det.pmat.block.diag <- function(x)
		{
		out <- lapply(x,function(x)prod(eigen(x)$val))
		attributes(out) <- attributes(x)
		out
		}

	det.pmat.block.default <- function(x)
		{
		stop("determinant not defined for general block mat")
		}

	solve.pmat.block.default <- function(x)
		{
		stop("inverse not defined for general block mat")
		}
  	if (version$major >= 5)
	{
	dist <- 
	function(x, metric = "euclidean")
	{
	# need to overwrite!  because it now bombs on inputs of length 1
	if (length(x)==1){
	out <- 0
	attr(out,"Size")<-1
	return(out)
	}
	        choices <- c("euclidean", "maximum", "manhattan", "binary")
	        i <- pmatch(metric, choices)
	        if(is.na(i))
	                stop(paste(metric, "is not a valid metric:", paste(choices,
	                        collapse = ", ")))
	        x <- as.matrix(x)
	        dd <- as.integer(dim(x))
	        if(i < 4)
	                x <- as.double(x)
	        else x <- as.double(as.logical(x))
	        # 0-1 values only
	        nr <- el(dd, 1)
	        nc <- el(dd, 2)
	        n <- (nr * (nr - 1))/2
	        data <- .Fortran("ddistca",
	                as.double(x),
	                nr,
	                nc,
	                data = double(n),
	                as.integer(i),
	                NAOK = T)$data
	        attr(data, "Size") <- nr
	        data
	}
	}


	dist2full <- function(dis)
	{
	        n <- attr(dis, "Size")
	        full <- matrix(0, n, n)
	        full[lower.tri(full)] <- dis
	        full + t(full)
	}
	msplit <- function(mat, vec)
	{
	        if(nrow(mat) != length(vec)) {
	                print("msplit: dimension error.")
	                return()
	        }
	        ns <- dimnames(mat)[[2]]
	        tstruc <- split.preserveord(as.vector(vec), as.vector(vec))
	        ngrp <- length(tstruc)
	        nco <- ncol(mat)
	        start <- 1
	        for(i in 1:ngrp) {
	                thislen <- length(tstruc[[i]])
	                end <- start + thislen - 1
	                tstruc[[i]] <- matrix(mat[seq(start, end),  ], ncol = nco)
	                dimnames(tstruc[[i]]) <- list(NULL,ns)
	                start <- end + 1
	        }
	        tstruc
	}

	rdim <- function(x)
	attr(x, "rdim")
	cdim <- function(x)
	attr(x, "cdim")

	pmat2mat <- function(x)
	{
	        if(inherits(x, "diag"))
	                stop("will not convert block diagonals")
	        R <- rdim(x)
	        C <- cdim(x)
	        N <- length(x)
	        k <- 0
	        if(inherits(x, "vstack")) {
	                out <- matrix(NA, nr = sum(rdim(x)), nc = cdim(x)[1])
	                for(i in 1:N) {
	                        k <- k + R[i]
	                        j <- k - R[i] + 1
	                        out[j:k,  ] <- x[[i]]
	                }
	        }
	        else if(inherits(x, "hstack")) {
	                out <- matrix(NA, nc = sum(cdim(x)), nr = rdim(x)[1])
	                for(i in 1:N) {
	                        k <- k + C[j]
	                        j <- k - C[j] + 1
	                        out[, j:k] <- x[[i]]
	                }
	        }
	        else stop("pmat to matrix conversions only defined for hstack and vstack")
	        out
	}

	transfer.matfun <- function(x)
	{
	if (!is.matrix(x)) 
	stop("transfer.matfun must receive a matrix")
	x
	}

	split.preserveord <- function(x, disc)
	{
	        tmpn <- unique(disc)
	        ansscr <- split(x, disc)
	        ord <- match(tmpn, names(ansscr))
	        ansscr[ord]
	}

	load.clustered.design <- function(x, id)
		fill( transfer.matfun, msplit(x,id), 
	               c("pmat","block","vstack"))

	vsplit <- function(vec, disc)
	{
	        lapply(split.preserveord(vec, disc), function(x)
	        matrix(x, nc = 1))
	}

	load.clustered.outcome <- function(y, id)
		fill( transfer.matfun, vsplit(y,id), 
	               c("pmat","block","vstack"))

	load.bd.weight <- function( matfun, genarg )
		{
		fill ( matfun, genarg, c("pmat","block","diag"))
		}

	make.exch.cor.genarg <- function(rho,id)
		{
		ni <- unlist(lapply(split.preserveord(id,id),length))
		N <- length(ni)
		ga <- list()
		for (i in 1:N)
			{
			ga[[i]]$ni <- ni[i]
			ga[[i]]$rho <- rho
			}
		ga
		}

	exch.cor <- function(x)
		{
		nr <- x$ni
		out <- matrix(x$rho,nr=nr,nc=nr)
		diag(out) <- 1
		out
		}

	exch.gaussian.loglik <- function( beta, rho, var, y, x, id )
		{
		Y <- load.clustered.outcome(y,id)
		X <- load.clustered.design(x,id)
		N <- length(y)
		Sig <- var * load.bd.weight(exch.cor, make.exch.cor.genarg( rho, id ) )
		D <- det(Sig)
		R <- load.clustered.outcome(y-x%*%beta,id) # structure resids
		WCPa <- t(R) %*% solve(Sig)
		WCP <- WCPa %*% R
		-.5*N*log(2*pi) -.5*sum(log(unlist(D))) -.5*sum(WCP)
		}

	#demo <- load.bd.weight(exch.cor, make.exch.cor.genarg(0.8016, Test.id))
	#W <- solve(demo)
	#TR <- t(AX) %*% W
	# obtains GLS for exchangeable gee
	#solve(sum(TR %*% AX)) %*% sum(TR %*% AY)




  yags.FS.fit <- function()
  {
  # obsolete, kept to illustrate IRWLS fisher scoring approach
  	MX <- pmat2mat(X)
  	b0 <- glm(unlist(Y) ~ MX - 1, family = family)$coef
  	del <- 1
  	NC <- length(Y)
  	while(del > 1e-05) {
  		print(b0)
  		eta <- MX %*% b0
  		mu <- family()$inverse(eta)
  		d.mu <- family()$deriv(mu)
  		A <- family()$variance(mu)
  		if(length(A) == 1)
  			A <- rep(A, length(unlist(Y)))
  		winv <- d.mu^2 * A  # i.e., 1/W with W from p43 of M&N
  		Rvec <- unlist(Y) - mu
  		WL <- split.preserveord(winv, ID)
  		RL <- split.preserveord(Rvec, ID)
  		AL <- split.preserveord(A,ID)
  		alpha <- alpfun(Rvec, ID, scalefun, p = ncol(MX))
  		cor.els <- list()
  		for(i in 1:NC)
  			cor.els[[i]] <- list(r = RL[[i]], wi = WL[[i]], 
                                 	a=AL[[i]], alpha = alpha)
  		z <- eta + (unlist(Y) - mu) * d.mu
  		z <- load.clustered.outcome(z, ID)
  # need slight redesign so that wcor is derived from V and wcor
  		Wi <- fill(wcorgen, cor.els, c("pmat", "block", "diag"))
  		b1 <- solve(sum(t(X) %*% Wi %*% X)) %*% sum(t(X) %*% Wi %*% z)
  		del <- max(abs(b1 - b0))
  		b0 <- b1
  	}
  	phi <- scalefun(Rvec,ID,p=ncol(MX))
  	glm.links <- yags.links
  	dmde <- family()$dinv.deta(eta)
  	D <- load.clustered.design(as.double(dmde)*MX,ID)
  	Wi <- fill(wcorgen, cor.els, c("pmat", "block", "diag"))
  	S2 <- solve(sum( t(D) %*% Wi %*% D ) )
  	SI <- fill(sandgen, cor.els, c("pmat", "block", "diag"))
  	SI <- sum( t(D) %*% SI %*% D )
  	sand <- S2 %*% SI %*% S2
          list(coef = b1, alpha = alpha, W1 = Wi[[1]], 
                 phi=phi, sandcov=sand, naicov=S2)
  }

  print.yags <-
  function(x, ...)
  {
  # borrowed from print.glm
  	if(!is.null(cl <- x$call)) {
  		cat("Call:\n")
  		dput(cl)
  	}
  	if (!is.null(x$errorcode)) {cat("\nError was:"); dput(x$errorcode);
                  warning("an error was detected in the fit")}
  	coef <- x$coef
  	if(any(nas <- is.na(coef))) {
  		if(is.null(names(coef)))
  			names(coef) <- paste("b", 1:length(coef), sep = "")	
  	#               coef <- coef[!nas]
  		cat("\nCoefficients: (", sum(nas), 
  			" not defined because of singularities)\n", sep = "")
  	}
  	else cat("\nCoefficients:\n")
  	print(coef, ...)
  	rank <- x$rank
  	if(is.null(rank))
  		rank <- sum(!nas)
  	nobs <- length(x$residuals)
  	rdf <- x$df.resid
  	if(is.null(rdf))
  		rdf <- nobs - rank
  	cat("\nDegrees of Freedom:", nobs, "Total;", rdf, "Residual\n")	
  	#cat("Residual Deviance:", format(x$deviance), "\n")
  	cat("\nWorking alpha:\n")
      if (x$corstr=="unstructured" && x$hardcode)
          {
          print(matrix(x$alpha,nr=sqrt(length(x$alpha))))
          }
      else if (x$corstr=="unstructured" && x$hardcode==F)
          {
          print(tri2full(x$alpha))
          }
      else cat(round(x$alpha,5))
  	cat("\n")
  	invisible(x)
  }

  summary.yags <-
  function(object, correlation = T)
  {
  # summary.yags
  # based on gee Splus support  geeformula.q 4.13 98/01/26
  	coef <- object$coefficients
  	resid <- object$residuals
  	n <- length(resid)
  	p <- object$rank
  	if(is.null(p))
  		p <- sum(!is.na(coef))
  	if(!p) {
  		warning("This model has zero rank --- no summary is provided")
  		return(object)
  	}
  	nas <- is.na(coef)
  	cnames <- names(coef[!nas])
  	coef <- matrix(rep(coef[!nas], 5), ncol = 5)
  	dimnames(coef) <- list(cnames, c("Estimate", "Naive S.E.", "Naive z", 
  		"Robust S.E.", "Robust z"))
  	rse <- sqrt(diag(object$robust.parmvar))
  	nse <- sqrt(diag(object$naive.parmvar))
  	coef[, 2] <- nse
  	coef[, 3] <- coef[, 1]/coef[, 2]
  	coef[, 4] <- rse
  	coef[, 5] <- coef[, 1]/coef[, 4]
  	summary <- list()
  	summary$call <- object$call
  	summary$version <- object$version
  	summary$nobs <- object$nobs
  	summary$residual.summary <- quantile(as.vector(object$residuals))
  	names(summary$residual.summary) <- c("Min", "1Q", "Median", "3Q", "Max"
  		)
  	summary$model <- object$model
  	summary$title <- object$title
  	summary$coefficients <- coef
  	summary$working.correlation <- object$working.correlation
  	summary$scale <- object$phi
  	if(!is.null(object$errorcode)) 
                {
                summary$error <- paste("Error code was", object$errorcode)
                warning("an error was detected in the fit")
                }
  	summary$alpha <- object$alpha
  	summary$sealp <- object$sealp
  	summary$iter <- object$iter
  	summary$hardcode <- object$hardcode
  	summary$corstr <- object$corstr
  	if(correlation) {
  #	rob.var <- object$robust.variance
  #	nai.var <- object$naive.variance
  #	summary$robust.correlation <- rob.var /
  #	outer(sqrt(diag(rob.var)),sqrt(diag(rob.var)))
  #	dimnames(summary$robust.correlation) <- list(object$xnames,object$xnames)
  #	summary$naive.correlation <- nai.var /
  #	outer(sqrt(diag(nai.var)),sqrt(diag(nai.var)))
  #	dimnames(summary$naive.correlation) <- list(object$xnames,object$xnames)
  	}
  	attr(summary, "class") <- "summary.yags"
  	summary
  }

  print.summary.yags <- 
  function(x, digits = NULL, quote = F, prefix = "")
  {
  # based on
  # gee Splus support  geeformula.q 4.13 98/01/26
  	if(is.null(digits)) digits <- options()$digits else options(digits = 
  			digits)
  	cat("\nCall:\n")
  	dput(x$call)
  	if (!is.null(x$error)) {cat("\n");dput(x$error)}
  	cat("\nSummary of raw residuals:\n")
  	print(x$residual.summary, digits = digits)
  	nas <- x$nas
  	if(any(nas))
  		cat("\n\nCoefficients: (", sum(nas), 
  			" not defined because of singularities)\n", sep = "")
  	else cat("\n\nCoefficients:\n")
  	print(x$coefficients, digits = digits)
  	cat("\nEstimated Scale Parameter: ", format(round(x$scale, digits)))
  	cat("\nNumber of Iterations: ", x$iter)
  	cat("\n\nWorking Correlation Parameter(s)\n")
  if (x$hardcode==T && x$corstr=="unstructured")
  	print(matrix(x$alpha,nc=sqrt(length(x$alpha))))
  else if (x$hardcode == F && x$corstr=="unstructured")
           print(tri2full(x$alpha))
  else print(x$alpha)
  #	cat("\n\ns.e. of Working Correlation Parameter(s)\n")
  #	print(as.numeric(x$sealp), digits = digits)
  	if(!is.null(x$naive.correlation)) {
  		cat("\n\nNaive correlation of regression parameter estimates:\n"
  			)
  		print(x$naive.correlation)
  	}
  	if(!is.null(x$robust.correlation)) {
  		cat("\n\nRobust correlation of regression parameter estimates:\n"
  			)
  		print(x$robust.correlation)
  	}
  	invisible(x)
  }

  
  ICIdat <- structure(.Data = list(pct.correct = c(28.57, 53, 57.83, 59.22, 13, 21, 26.5, 
  	60.37, 86.41, 33.87, 55.5, 61.06, 1.61, 0.69, 26.04, 61.98, 67.28, 59, 
  	66.8, 83.2, 11.29, 38.02, 0, 0, 0, 2.76, 35.1, 37.79, 54.8, 16, 33, 
  	45.39, 40.09, 40.55, 50.69, 41.7, 52.07, 3.9, 11.06, 4.15, 14.9, 1.8, 
  	2.3, 2.53, 2.53, 0, 17.74, 44.7, 48.85, 64.75, 84.5, 92.4, 95.39, 38.25,
  	81.57, 89.63, 67.5, 91.47, 92.86, 45.62, 58, 0, 0, 37, 51.15, 66.13, 0, 
  	48.16, 0, 0.92, 0, 0.9, 1.61, 0, 0, 0, 0, 0, 8.76, 24.42, 0, 20.79, 
  	27.42, 31.8, 2.3, 12.67, 28.8, 24.42, 12.9, 28.34, 45.5, 43.32, 36.8, 
  	68, 96.08, 97.47, 99, 20.28, 41.01, 51.15, 61.98, 65.9, 81.3, 71.2, 70, 
  	0, 8.76, 16.59, 14.75, 0, 0, 0, 0, 9.22, 14.98, 9.68, 11.29, 44.47, 
  	62.9, 68.2, 30.88, 29.72, 29.72, 41.4, 64, 0, 43.55, 48.16, 0, 0, 8.76, 
  	60, 8, 25, 30.88, 55.53), months.post = c(1, 9, 18, 30, 9, 18, 30, 1, 9,
  	1, 9, 18, 1, 9, 1, 9, 18, 9, 18, 30, 1, 9, 1, 9, 18, 30, 9, 18, 30, 1, 
  	9, 18, 30, 1, 9, 18, 30, 1, 9, 18, 30, 1, 9, 18, 30, 1, 9, 18, 30, 1, 9,
  	18, 30, 1, 9, 18, 1, 9, 18, 1, 9, 1, 9, 18, 1, 9, 1, 9, 1, 9, 9, 18, 30,
  	1, 9, 18, 1, 9, 1, 9, 1, 9, 18, 30, 1, 9, 18, 30, 1, 9, 9, 18, 30, 1, 9,
  	18, 30, 1, 9, 18, 30, 1, 9, 18, 30, 1, 9, 18, 30, 1, 9, 18, 30, 1, 9, 
  	18, 1, 9, 18, 30, 1, 9, 1, 9, 18, 1, 9, 18, 1, 9, 1, 9, 1, 9, 18, 30), 
  	id = c(1, 1, 1, 1, 2, 2, 2, 3, 3, 4, 4, 4, 5, 5, 6, 6, 6, 7, 7, 7, 8, 8,
  	9, 9, 9, 9, 10, 10, 10, 11, 11, 11, 11, 12, 12, 12, 12, 13, 13, 13, 13, 
  	14, 14, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 17, 17, 17, 18, 18, 18, 
  	19, 19, 20, 20, 20, 21, 21, 22, 22, 23, 23, 24, 24, 24, 25, 25, 25, 26, 
  	26, 27, 27, 28, 28, 28, 28, 29, 29, 29, 29, 30, 30, 31, 31, 31, 32, 32, 
  	32, 32, 33, 33, 33, 33, 34, 34, 34, 34, 35, 35, 35, 35, 36, 36, 36, 36, 
  	37, 37, 37, 38, 38, 38, 38, 39, 39, 40, 40, 40, 41, 41, 41, 42, 42, 43, 
  	43, 44, 44, 44, 44), trtgrp = c(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  	0, 0, 0)), class = "data.frame", row.names = c("1", "2", "3", "4", "5", 
  	"6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", 
  	"18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", 
  	"30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", 
  	"42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", 
  	"54", "55", "56", "57", "58", "59", "60", "61", "62", "63", "64", "65", 
  	"66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", 
  	"78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", 
  	"90", "91", "92", "93", "94", "95", "96", "97", "98", "99", "100", 
  	"101", "102", "103", "104", "105", "106", "107", "108", "109", "110", 
  	"111", "112", "113", "114", "115", "116", "117", "118", "119", "120", 
  	"121", "122", "123", "124", "125", "126", "127", "128", "129", "130", 
  	"131", "132", "133", "134", "135", "136"))

  Test.id <- c(1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 6, 
          6, 7, 7, 7, 7, 8, 8, 
  	8, 8, 9, 9, 9, 9, 10, 10, 10, 11, 11, 11, 11, 12, 12, 12, 12, 13, 13, 
  	13, 13, 14, 14, 14, 14, 15, 15, 15, 16, 16, 16, 17, 17, 17, 17, 18, 18, 
  	18, 18, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 22, 22, 23, 23, 23, 
  	24, 24, 24, 24, 25, 25, 25, 25, 26, 26, 26, 27, 27, 27, 27, 28, 28, 28, 
  	28, 29, 29, 30, 30, 30, 30, 31, 31, 31, 31, 32, 32, 32, 33, 33, 33, 33, 
  	34, 34, 34, 34, 35, 35, 35, 35, 36, 36, 36, 36, 37, 37, 37, 37, 38, 38, 
  	38, 38, 39, 39, 39, 39, 40, 40, 40, 41, 41, 41, 41, 42, 42, 42, 42, 43, 
  	43, 44, 44, 44, 45, 45, 45, 45, 46, 46, 46, 47, 47, 47, 47, 48, 48, 48, 
  	48, 49, 49, 50, 50, 50, 50, 51, 51, 51, 52, 52, 52, 52, 53, 53, 53, 53, 
  	54, 54, 54, 55, 55, 55, 55, 56, 56, 56, 56, 57, 57, 57, 57, 58, 58, 59, 
  	59, 59, 60, 60, 60, 60, 61, 61, 61, 61, 62, 62, 62, 63, 63, 63, 63, 64, 
  	64, 64, 64, 65, 65, 65, 66, 66, 66, 67, 67, 67, 67, 68, 68, 68, 68, 69, 
  	69, 69, 70, 70, 70, 70, 71, 71, 71, 71, 72, 72, 72, 73, 73, 73, 73, 74, 
  	74, 74, 74, 75, 75, 75, 76, 76, 76, 76, 77, 77, 77, 77, 78, 78, 78, 78, 
  	79, 79, 79, 80, 80, 80, 81, 81, 81, 81, 82, 82, 82, 83, 83, 83, 83, 84, 
  	84, 84, 84, 85, 85, 85, 85, 86, 86, 86, 86, 87, 87, 87, 87, 88, 88, 88, 
  	88, 89, 89, 89, 89, 90, 90, 90, 90, 91, 91, 91, 91, 92, 92, 92, 92, 93, 
  	93, 93, 93, 94, 94, 94, 94, 95, 95, 95, 96, 96, 96, 96, 97, 97, 97, 97, 
  	98, 98, 98, 99, 99, 99, 99, 100, 100, 100, 100, 101, 101, 101, 102, 102,
  	102, 103, 103, 103, 103, 104, 104, 104, 104, 105, 105, 105, 105, 106, 
  	106, 107, 107, 107, 108, 108, 108, 108, 109, 109, 109, 109, 110, 110, 
  	110, 110, 111, 111, 111, 111, 112, 112, 112, 112, 113, 113, 113, 113, 
  	114, 114, 114, 115, 115, 115, 115, 116, 116, 116, 116, 117, 117, 118, 
  	118, 118, 119, 119, 119, 120, 120, 120, 120, 121, 121, 122, 122, 122, 
  	122, 123, 123, 123, 123, 124, 124, 124, 124, 125, 125, 125, 125)


  Test.x <- structure(.Data = c(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
          1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 
  	1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 
  	1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 
  	1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 
  	1, 1, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 
  	1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 
  	0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 
  	1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 
  	1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 
  	1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 
  	1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 
  	0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 
  	1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 
  	0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 
  	1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 
  	1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 
  	0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 
  	0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 
  	0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 
  	0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1), .Dim = c(450, 2), 
  	.Dimnames = list(character(0), c("int", "trt")))


  Test.y <- c(-1.45929501289522, -2.45929501289522, -2.45929501289522, 
          -1.45929501289522, 
  	-1.42261502716641, -1.42261502716641, -1.42261502716641, 
  	-2.42261502716641, -1.35672715317461, -2.35672715317461, 
  	-1.35672715317461, -1.23353768699215, -2.23353768699215, 
  	-1.23353768699215, -2.23353768699215, -1.95722983124032, 
  	-0.957229831240323, -0.957229831240323, -0.761528002034406, 
  	-1.76152800203441, -0.700700569661634, -1.70070056966163, 
  	-0.700700569661634, -1.70070056966163, -1.67325886638217, 
  	-0.673258866382174, -0.673258866382174, -0.673258866382174, 
  	-0.625863978429798, -1.6258639784298, -1.6258639784298, 
  	-0.625863978429798, -0.60470965230343, -1.60470965230343, 
  	-0.60470965230343, -0.556408909506318, -0.556408909506318, 
  	-0.556408909506318, -1.55640890950632, -1.42179049284005, 
  	-0.421790492840052, -0.421790492840052, -1.42179049284005, 
  	-0.404724839316565, -1.40472483931656, -1.40472483931656, 
  	-0.404724839316565, -0.353166482858368, -0.353166482858368, 
  	-0.353166482858368, -1.35316648285837, -0.294310424429228, 
  	-0.294310424429228, -0.294310424429228, -1.27076524926181, 
  	-0.270765249261815, -0.270765249261815, -0.242237825122439, 
  	-0.242237825122439, -0.242237825122439, -1.24223782512244, 
  	-1.18376725478417, -1.18376725478417, -0.183767254784173, 
  	-1.18376725478417, -0.142369139718567, -0.142369139718567, 
  	-0.142369139718567, -0.118441464572309, -0.118441464572309, 
  	-1.11844146457231, -0.118441464572309, -0.108051749234125, 
  	-1.10805174923412, -1.10805174923412, -0.108051749234125, 
  	-1.03652548156517, -0.0365254815651743, -0.0216414274769596, 
  	-1.02164142747696, -1.02164142747696, 0.0320630658706269, 
  	0.0320630658706269, -0.967936934129373, -0.967936934129373, 
  	-0.952137383910066, 0.0478626160899339, 0.0478626160899339, 
  	0.0478626160899339, -0.917764850177658, 0.0822351498223416, 
  	0.0822351498223416, 0.101502073330602, 0.101502073330602, 
  	-0.898497926669398, -0.898497926669398, 0.126352073359833, 
  	-0.873647926640167, 0.126352073359833, 0.126352073359833, 
  	-0.843219234371682, 0.156780765628318, 0.172050770686466, 
  	0.172050770686466, -0.827949229313534, 0.172050770686466, 
  	0.237953937554664, 0.237953937554664, -0.762046062445336, 
  	0.237953937554664, 0.287096734995709, -0.712903265004291, 
  	-0.712903265004291, -0.646916651369085, 0.353083348630915, 
  	-0.646916651369085, 0.353083348630915, 0.406846740270258, 
  	0.406846740270258, -0.593153259729742, 0.406846740270258, 
  	0.414193419672014, -0.585806580327986, -0.585806580327986, 
  	-0.585806580327986, -0.582867798428667, 0.417132201571333, 
  	0.417132201571333, 0.417132201571333, -0.5634100762831, 
  	-0.5634100762831, 0.4365899237169, 0.4365899237169, 0.475133109001195, 
  	-0.524866890998805
  	, -0.524866890998805, 0.475133109001195, 0.488353799266315, 
  	-0.511646200733685, 0.488353799266315, -0.511646200733685, 
  	0.514018454971823, -0.485981545028177, 0.514018454971823, 
  	0.553574682450163, 0.553574682450163, -0.446425317549837, 
  	0.553574682450163, 0.556395660575645, -0.443604339424355, 
  	0.556395660575645, 0.556395660575645, -0.388402910983175, 
  	0.611597089016825, -0.345667300810752, -0.345667300810752, 
  	0.654332699189248, -0.315599655754603, -0.315599655754603, 
  	-0.315599655754603, 0.684400344245397, 0.692552324820737, 
  	0.692552324820737, -0.307447675179263, -0.28244486378212, 
  	-0.28244486378212, -0.28244486378212, 0.71755513621788, 
  	0.722973411978074, 0.722973411978074, 0.722973411978074, 
  	-0.277026588021926, 0.737073236979721, -0.262926763020279, 
  	-0.248718983587207, 0.751281016412793, -0.248718983587207, 
  	0.751281016412793, 0.805269371890978, -0.194730628109022, 
  	0.805269371890978, 0.815555476700771, 0.815555476700771, 
  	-0.184444523299229, 0.815555476700771, 0.818909451539492, 
  	0.818909451539492, -0.181090548460508, 0.818909451539492, 
  	0.831114394646985, 0.831114394646985, -0.168885605353015, 
  	-0.109916664614606, 0.890083335385394, -0.109916664614606, 
  	-0.109916664614606, -0.100217194673378, 0.899782805326622, 
  	0.899782805326622, 0.899782805326622, 0.912886055509927, 
  	-0.0871139444900735, -0.0871139444900735, -0.0871139444900735, 
  	0.924846961746019, 0.924846961746019, -0.0650913329290969, 
  	0.934908667070903, 0.934908667070903, 0.952767962949441, 
  	-0.047232037050559, -0.047232037050559, 0.952767962949441, 
  	1.00868508267532, 1.00868508267532, 1.00868508267532, 
  	0.00868508267532209, 1.00912464822413, 0.00912464822412941, 
  	0.00912464822412941, 0.0448075267732454, 1.04480752677325, 
  	1.04480752677325, 1.04480752677325, 1.06592537604955, 0.065925376049548,
  	1.06592537604955, 0.065925376049548, 1.06638079855592, 1.06638079855592,
  	1.06638079855592, 1.07595689815702, 0.0759568981570196, 
  	1.07595689815702, 1.0858711432174, 1.0858711432174, 0.0858711432173963, 
  	0.0858711432173963, 1.09873739144884, 0.0987373914488392, 
  	0.0987373914488392, 1.09873739144884, 0.101259514066805, 
  	0.101259514066805, 1.10125951406681, 1.18643804848851, 1.18643804848851,
  	0.186438048488514, 0.186438048488514, 1.18964823491823, 
  	1.18964823491823, 1.18964823491823, 0.189648234918228, 
  	0.198357403129744, 1.19835740312974, 1.19835740312974, 1.2401716429689, 
  	1.2401716429689, 1.2401716429689, 0.240171642968899, 1.24542336513821, 
  	0.24542336513821, 1.24542336513821, 1.24542336513821, 0.291905162191998,
  	1.291905162192, 0.291905162191998, 0.303514806136678, 1.30351480613668, 
  	0.303514806136678, 1.30351480613668, 0.303701969851944, 
  	1.30370196985194, 0.303701969851944, 1.30370196985194, 1.32395563303189,
  	0.323955633031888, 0.323955633031888, 1.32395563303189, 
  	1.34412994923204, 0.344129949232041, 1.34412994923204, 
  	0.372314330704888, 1.37231433070489, 1.37231433070489, 1.40777968696802,
  	0.40777968696802, 1.40777968696802, 1.40777968696802, 0.417472634255669,
  	0.417472634255669, 0.417472634255669, 1.44910206787461, 
  	1.44910206787461, 0.449102067874612, 0.449102067874612, 
  	0.453631521142682, 0.453631521142682, 0.453631521142682, 
  	1.45363152114268, 1.48992257298498, 0.489922572984985, 1.48992257298498,
  	1.48992257298498, 0.508864763733389, 0.508864763733389, 
  	1.50886476373339, 0.508864763733389, 1.51371598380787, 1.51371598380787,
  	1.51371598380787, 0.513715983807867, 0.536222095060352, 
  	1.53622209506035, 1.53622209506035, 0.536222095060352, 
  	0.559186989425765, 0.559186989425765, 1.55918698942576, 
  	1.55918698942576, 1.56273335497435, 1.56273335497435, 1.56273335497435, 
  	0.56273335497435, 0.582297380205099, 1.5822973802051, 1.5822973802051, 
  	0.582297380205099, 1.58368453834604, 0.58368453834604, 0.58368453834604,
  	0.58368453834604, 1.6879707584887, 1.6879707584887, 1.6879707584887, 
  	1.6879707584887, 1.72323616470784, 1.72323616470784, 0.723236164707837, 
  	1.72323616470784, 0.749582735470073, 1.74958273547007, 
  	0.749582735470073, 1.74959058286234, 0.749590582862345, 
  	1.74959058286234, 0.749590582862345, 1.79639782418085, 1.79639782418085,
  	0.796397824180853, 1.79639782418085, 0.803162292176938, 
  	1.80316229217694, 1.80316229217694, 0.877708346426933, 1.87770834642693,
  	1.87770834642693, 1.87770834642693, 0.887564070435032, 1.88756407043503,
  	1.88756407043503, 1.88756407043503, 0.907460529992338, 
  	0.907460529992338, 1.90746052999234, 0.963504211735934, 
  	0.963504211735934, 0.963504211735934, 0.986758659578851, 
  	0.986758659578851, 0.986758659578851, 1.98675865957885, 
  	1.05607547581777, 2.05607547581777, 2.05607547581777, 1.05607547581777, 
  	1.09345678354118, 2.09345678354118, 1.09345678354118, 2.09345678354118, 
  	2.09769715004297, 1.09769715004297, 2.23807700512581, 2.23807700512581, 
  	1.23807700512581, 1.26986158027416, 1.26986158027416, 2.26986158027416, 
  	2.26986158027416, 1.27173450210602, 1.27173450210602, 2.27173450210602, 
  	2.27173450210602, 2.32382209161586, 2.32382209161586, 1.32382209161586, 
  	2.32382209161586, 1.34946448499285, 1.34946448499285, 2.34946448499285, 
  	2.34946448499285, 2.35172992126846, 1.35172992126846, 1.35172992126846, 
  	1.35172992126846, 2.35936981699885, 1.35936981699885, 1.35936981699885, 
  	2.35936981699885, 1.43504492436969, 2.43504492436969, 2.43504492436969, 
  	2.46745534225684, 1.46745534225684, 2.46745534225684, 2.46745534225684, 
  	2.47443235110756, 2.47443235110756, 2.47443235110756, 1.47443235110756, 
  	1.48592734824168, 2.48592734824168, 2.54472021553224, 1.54472021553224, 
  	2.54472021553224, 1.69303173364691, 2.69303173364691, 1.69303173364691, 
  	3.24852246860984, 2.24852246860984, 3.24852246860984, 3.24852246860984, 
  	3.28681399691707, 3.28681399691707, 2.46456956453342, 3.46456956453342, 
  	3.46456956453342, 3.46456956453342, 3.48467422377203, 2.48467422377203, 
  	3.48467422377203, 3.48467422377203, 3.69330758977152, 3.69330758977152, 
  	2.69330758977152, 3.69330758977152, 3.99062594148916, 3.99062594148916, 
  	3.99062594148916, 2.99062594148916)


  BAlr.y <- structure(.Data = c(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 
  	1, 1, 0, 0, 1, 0, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 
  	1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 
  	0, 1, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 
  	0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 
  	1, 1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1), 
  	.Names = c("11", "12", "13", "14", "21", "22", "23", "24", "31", "32", 
  	"33", "41", "42", "43", "44", "51", "52", "53", "61", "62", "71", "72", 
  	"73", "74", "81", "82", "83", "84", "91", "92", "93", "94", "101", 
  	"102", "103", "111", "112", "113", "114", "121", "122", "123", "124", 
  	"131", "132", "133", "134", "141", "142", "143", "144", "151", "152", 
  	"153", "161", "162", "163", "171", "172", "173", "174", "181", "182", 
  	"183", "184", "191", "192", "193", "201", "202", "203", "204", "211", 
  	"212", "213", "214", "221", "222", "231", "232", "233", "241", "242", 
  	"243", "244", "251", "252", "253", "254", "261", "262", "263", "271", 
  	"272", "273", "274", "281", "282", "283", "284", "291", "292", "301", 
  	"302", "303", "304", "311", "312", "313", "314", "321", "322", "323", 
  	"331", "332", "333", "334", "341", "342", "343", "344", "351", "352", 
  	"353", "354", "361", "362", "363", "364", "371", "372", "373", "374", 
  	"381", "382", "383", "384", "391", "392", "393", "394", "401", "402", 
  	"403", "411", "412", "413", "414", "421", "422", "423", "424", "431", 
  	"432", "441", "442", "443", "451", "452", "453", "454", "461", "462", 
  	"463", "471", "472", "473", "474", "481", "482", "483", "484", "491", 
  	"492", "501", "502", "503", "504", "511", "512", "513", "521", "522", 
  	"523", "524", "531", "532", "533", "534", "541", "542", "543", "551", 
  	"552", "553", "554", "561", "562", "563", "564", "571", "572", "573", 
  	"574", "581", "582", "591", "592", "593", "601", "602", "603", "604", 
  	"611", "612", "613", "614", "621", "622", "623", "631", "632", "633", 
  	"634", "641", "642", "643", "644", "651", "652", "653", "661", "662", 
  	"663", "671", "672", "673", "674", "681", "682", "683", "684", "691", 
  	"692", "693", "701", "702", "703", "704", "711", "712", "713", "714", 
  	"721", "722", "723", "731", "732", "733", "734", "741", "742", "743", 
  	"744", "751", "752", "753", "761", "762", "763", "764", "771", "772", 
  	"773", "774", "781", "782", "783", "784", "791", "792", "793", "801", 
  	"802", "803", "811", "812", "813", "814", "821", "822", "823", "831", 
  	"832", "833", "834", "841", "842", "843", "844", "851", "852", "853", 
  	"854", "861", "862", "863", "864", "871", "872", "873", "874", "881", 
  	"882", "883", "884", "891", "892", "893", "894", "901", "902", "903", 
  	"904", "911", "912", "913", "914", "921", "922", "923", "924", "931", 
  	"932", "933", "934", "941", "942", "943", "944", "951", "952", "953", 
  	"961", "962", "963", "964", "971", "972", "973", "974", "981", "982", 
  	"983", "991", "992", "993", "994", "1001", "1002", "1003", "1004", 
  	"1011", "1012", "1013", "1021", "1022", "1023", "1031", "1032", "1033", 
  	"1034", "1041", "1042", "1043", "1044", "1051", "1052", "1053", "1054", 
  	"1061", "1062", "1071", "1072", "1073", "1081", "1082", "1083", "1084", 
  	"1091", "1092", "1093", "1094", "1101", "1102", "1103", "1104", "1111", 
  	"1112", "1113", "1114", "1121", "1122", "1123", "1124", "1131", "1132", 
  	"1133", "1134", "1141", "1142", "1143", "1151", "1152", "1153", "1154", 
  	"1161", "1162", "1163", "1164", "1171", "1172", "1181", "1182", "1183", 
  	"1191", "1192", "1193", "1201", "1202", "1203", "1204", "1211", "1212", 
  	"1221", "1222", "1223", "1224", "1231", "1232", "1233", "1234", "1241", 
  	"1242", "1243", "1244", "1251", "1252", "1253", "1254"))


  Alr.trt <- structure(.Data = c(0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 
  	0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 
  	0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 
  	0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 
  	0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 
  	1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 
  	1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 
  	0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 
  	1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 
  	1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 
  	1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 
  	0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 
  	1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 
  	0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 
  	0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 
  	1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 
  	0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 
  	1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 
  	0, 0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1), .Dim
  	 = c(450, 1), .Dimnames = list(character(0), "trt"))

  Test.times <- 
  c(1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 1, 2, 1, 2, 3, 4, 1, 2, 
          3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 
          4, 1, 2, 3, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 
          3, 4, 1, 2, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 
          3, 4, 1, 2, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 
          2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 
          3, 4, 1, 2, 3, 4, 1, 2, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 
          3, 4, 1, 2, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 
          3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 
          2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 
          1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 
          3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 1, 2, 3, 4, 1, 
          2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 
          3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 
          3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 
          1, 2, 3, 1, 2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 1, 2, 3, 1, 
          2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 
          2, 3, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 1, 2, 3, 1, 2, 3, 1, 2, 3, 4, 1, 2, 
          1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4)



